#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "matrix.h"

// TODO Matrix-Funktionen implementieren

Matrix createMatrix(unsigned int rows, unsigned int cols)
{
    Matrix matrix;
    Matrix empty = {0, 0, NULL};

    if(rows == 0 || cols == 0)
    {
        //print("Fehler: Dimensionen muessen >= 1 sein!");
        return empty;
    }

    matrix.rows = rows;
    matrix.cols = cols;
    matrix.buffer = malloc(rows * cols * sizeof(float));

    if(matrix.buffer == NULL)
    {
        //printf("Fehler bei der Speicherreservierung! Keine Matrix erstellt!");
        matrix.rows = 0;
        matrix.cols = 0;
    }

    return matrix;
}

void clearMatrix(Matrix *matrix)
{
    free(matrix->buffer);

    matrix->buffer = NULL;
    matrix->rows = 0;
    matrix->cols = 0;
}

void setMatrixAt(MatrixType value, Matrix matrix, unsigned int rowIdx, unsigned int colIdx)
{
    if(matrix.buffer == NULL)
    {
        //printf("Fehler beim Setzen! Matrix nicht initialisiert");
        return;
    }

    // printf("rowIdx %d\n", rowIdx);
    // printf("mat.row %d\n", matrix.rows);
    // printf("colIdx %d\n", colIdx);
    // printf("mat.cols %d\n", matrix.cols);

    if(rowIdx >= matrix.rows || colIdx >= matrix.cols)
    {
        //printf("Ungueltige Indizes beim Setzen!\n");
        return;
    }
    // printf("%d \n", rowIdx + matrix.cols * colIdx);
    matrix.buffer[rowIdx + matrix.cols * colIdx] = value;
    // printf("value %f\n", value);
}

MatrixType getMatrixAt(const Matrix matrix, unsigned int rowIdx, unsigned int colIdx)
{
    if(matrix.buffer == NULL)
    {
        //printf("Fehler beim Lesen! Matrix nicht initialisiert");
        return 0;
    }

    if(rowIdx >= matrix.rows || colIdx >= matrix.cols)
    {
        //printf("Ungueltige Indizes beim Lesen!\n");
        return 0;
    }

    return matrix.buffer[rowIdx * matrix.cols + colIdx];
}

Matrix add(const Matrix matrix1, const Matrix matrix2)
{
    float matrix1Wert = 0;
    float matrix2Wert = 0;
    float summe = 0;
    int broadcasting = 0;

    Matrix broadcastedmatrix1 = {0,0,NULL};
    Matrix broadcastedmatrix2 = {0,0,NULL};

    if((matrix1.rows != matrix2.rows) || (matrix1.cols != matrix2.cols))
    {
        if((matrix1.rows != matrix2.rows) && (matrix1.cols == matrix2.cols))
        {
            if(matrix1.rows == 1)
            {
                broadcastedmatrix1 = createMatrix(matrix2.rows, matrix2.cols);

                for(int row = 0; row<matrix2.rows; row++)
                {
                    for(int col = 0; col<matrix2.cols; col++)
                    {
                        matrix1Wert = getMatrixAt(matrix1, 0, col);
                        setMatrixAt(matrix1Wert, broadcastedmatrix1, row, col);
                    }
                }

                broadcasting = 1;
            }
            else if(matrix2.rows == 1)
            {
                broadcastedmatrix2 = createMatrix(matrix1.rows, matrix1.cols);
                
                for(int row = 0; row<matrix1.rows; row++)
                {
                    for(int col = 0; col<matrix1.cols; col++)
                    {
                        matrix2Wert = getMatrixAt(matrix2, 0, col);
                        setMatrixAt(matrix2Wert, broadcastedmatrix2, row, col);
                    }
                }

                broadcasting = 2;
            }
        }
        else if((matrix1.rows == matrix2.rows) && (matrix1.cols != matrix2.cols))
        {
            if(matrix1.cols == 1)
            {
                broadcastedmatrix1 = createMatrix(matrix2.rows, matrix2.cols);

                for(int row = 0; row<matrix2.rows; row++)
                {
                    for(int col = 0; col<matrix2.cols; col++)
                    {
                        matrix1Wert = getMatrixAt(matrix1, row, 0);
                        setMatrixAt(matrix1Wert, broadcastedmatrix1, row, col);
                    }
                }

                broadcasting = 1;
            }
            else if(matrix2.cols == 1)
            {
                broadcastedmatrix2 = createMatrix(matrix1.rows, matrix1.cols);

                for(int row = 0; row<matrix1.rows; row++)
                {
                    for(int col = 0; col<matrix1.cols; col++)
                    {
                        matrix2Wert = getMatrixAt(matrix2, row, 0);
                        setMatrixAt(matrix2Wert, broadcastedmatrix2, row, col);
                    }
                }

                broadcasting = 2;
            }
        }
        else
        {
        //printf("Fehler bei Addition: Matrix Dimensionen stimmen nicht ueberein!\n");
        Matrix empty = {0, 0, NULL};
        return empty;
        }
    }

    Matrix ergebnisMatrix;

    switch (broadcasting)
    {
        case 0:
        case 2:
            ergebnisMatrix = createMatrix(matrix1.rows, matrix1.cols);
        break;

        case 1:
            ergebnisMatrix = createMatrix(matrix2.rows, matrix2.cols);
        break;
    }

    for(int row = 0; row < ergebnisMatrix.rows; row++)
    {
        for(int col = 0; col < ergebnisMatrix.cols; col++)
        {
            if(broadcasting == 0)
            {
                matrix1Wert = getMatrixAt(matrix1, row, col);
                matrix2Wert = getMatrixAt(matrix2, row, col);
                summe = matrix1Wert + matrix2Wert;
            }
            else if(broadcasting == 1)
            {
                matrix1Wert = getMatrixAt(broadcastedmatrix1, row, col);
                matrix2Wert = getMatrixAt(matrix2, row, col);
                summe = matrix1Wert + matrix2Wert;
            }
            else if(broadcasting == 2)
            {
                matrix1Wert = getMatrixAt(matrix1, row, col);
                matrix2Wert = getMatrixAt(broadcastedmatrix2, row, col);
                summe = matrix1Wert + matrix2Wert;
            }

            setMatrixAt(summe, ergebnisMatrix, row, col);
        }
    }

    clearMatrix(&broadcastedmatrix1);
    clearMatrix(&broadcastedmatrix2);

    return ergebnisMatrix;
}

Matrix multiply(const Matrix matrix1, const Matrix matrix2)
{
    if(matrix1.cols != matrix2.rows)
    {
        //printf("Fehler bei Multiplikation: Matrix Dimensionen passen nicht ueberein!\n");
        Matrix empty = {0, 0, NULL};
        return empty;
    }

    float erg = 0;

    Matrix ergebnisMatrix = createMatrix(matrix1.rows, matrix2.cols);

    for(int row = 0; row < ergebnisMatrix.rows; row++)
    {
        for(int col = 0; col < ergebnisMatrix.cols; col++)
        {
            erg = 0;

            for(int k = 0; k < matrix1.cols; k++)
            {
                erg += getMatrixAt(matrix1, row, k) * getMatrixAt(matrix2, k, col);
            }

            setMatrixAt(erg, ergebnisMatrix, row, col);
        }
    }

    return ergebnisMatrix;
}
